; ############################################
; #      Crash Ntice with Page Faults        #
; #                                          #
; # Lionel d'Hauenens * labo@labo-asso.com * #
; #    -= http://www.labo-asso.com/ =-     #
; ############################################

; --------------------------------------
; Compilation (nasm et alink)
; --------------------------------------
; set name=crash_ice_with_eip_scan
; 
; nasmw.exe -fobj -O3 %name%.asm 
; alink.exe -oPE %name%.obj
; --------------------------------------

BITS 32

;**********************************************
;*                  STRUCTURES                *
;**********************************************
%include "win32_structs.asm"

;**********************************************
;*                  CONSTANTES                *
;**********************************************

    MB_OK                       equ 0h
    MB_YESNO                    equ 4h
    MB_ICONEXCLAMATION          equ 30h
    MB_ICONASTERISK             equ 40h
    IDYES                       equ 6
    IDNO                        equ 7

    SystemModuleInformation     equ 11
    
    MEM_COMMIT                  equ 01000h
    PAGE_READWRITE              equ 04
    MEM_RELEASE                 equ 08000h

    size_bloc                   equ 0100h
    minimum_size_module         equ 00100000h

;**********************************************
;*                    MACROS                  *
;**********************************************
%define saut    db 0Dh,0Ah

;**********************************************
;*                   IMPORTS                  *
;**********************************************
; -----------
;   Ntdll
; -----------
extern NtQuerySystemInformation
import NtQuerySystemInformation ntdll.dll
; -----------
;   Kernel32
; -----------
extern ExitProcess
import ExitProcess  kernel32.dll
extern VirtualAlloc
import VirtualAlloc kernel32.dll
extern VirtualFree
import VirtualFree  kernel32.dll
; -----------
;   User32
; -----------
extern MessageBoxA
import MessageBoxA user32.dll     

 ; ------------------------------------------------------------------------------
  SEGMENT data? USE32 class=data
 ; ------------------------------------------------------------------------------

    resultat                    dd 0
    buffer                      dd 0
ALIGN 4
    r_a_s                       db "Rien A Signaler :)",0
ALIGN 4
    titre_attention db "Attention !!!",0
ALIGN 4
    text_attention  db "La prsence de Softice va tre vrifie par une mthode"
                    saut
                    db "qui aboutit  un crash systme si celui-ci est prsent."
                    saut
                    saut
                    db "Voulez-vous quand mme continuer ?",0

 ; ------------------------------------------------------------------------------
  SEGMENT code USE32 CLASS=code
 ; ------------------------------------------------------------------------------

..start :

;int 3

    ; rcupre la taille du buffer
    push resultat
    push 0
    push 0
    push SystemModuleInformation
    call [NtQuerySystemInformation]

    ; cre le buffer pour les
    ; infos des modules
    push PAGE_READWRITE
    push MEM_COMMIT
    push dword [resultat]
    push 0
    call [VirtualAlloc]
    mov dword [buffer],eax

    ; rcupre les infos
    ; sur les modules
    push resultat
    push dword [resultat]
    push dword [buffer]
    push SystemModuleInformation
    call [NtQuerySystemInformation]

    ; Message : Attention a va crasher
    push (MB_ICONEXCLAMATION | MB_YESNO)
    push titre_attention
    push text_attention
    push 0
    call [MessageBoxA]
    cmp eax, IDYES
    jne sortie

    mov eax, dword [buffer]
    mov ecx, dword [eax+SYSTEM_MODULE_INFORMATION.Count]  ; nombre de modules
    lea ebp, [eax+ SYSTEM_MODULE_INFORMATION.Module]      ; premier INFORMATION_ENTRY
    
    ; Installe un handler d'exception
    push SEH
    push dword [fs:0]
    mov dword [fs:0], esp
    
    ; scanne la mmoire systme
    ; avec le registre eip
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
boucle_module :
    mov ebx, dword [ebp+SYSTEM_MODULE_INFORMATION_ENTRY.Size]

    ; ignore tous les petits modules (optimisation)
    cmp ebx, minimum_size_module
    jb continue_boucle

    mov eax, dword [ebp+SYSTEM_MODULE_INFORMATION_ENTRY.Base]
    ; end module
    add ebx, eax
    
boucle_scan :
    jmp eax     ; scanne dans la mmoire systme -> gnre une faute de page
                ; (graduation de "size_bloc" octets -> optimisation)
continue :
    add eax, size_bloc
    cmp eax, ebx
    jb boucle_scan

continue_boucle :
    add ebp, SIZEOF_SYSTEM_MODULE_INFORMATION_ENTRY
    loop boucle_module

    ; Enlve l'handler d'exception
    mov esp, dword [fs:0]
    pop dword [fs:0]
    add esp, 04
    
    ; Message : Rien  signaler
    push (MB_ICONASTERISK | MB_OK)
    push r_a_s
    push r_a_s
    push 0
    call [MessageBoxA]
    
sortie :
    ; detruit le buffer infos modules
    push MEM_RELEASE
    push 0
    push dword [buffer]
    call [VirtualFree]

    ; Tchao !...  bella tchao, bella tchao, bella tchao tchao tchao ! ;)
    push 0
    call [ExitProcess]
    ret

; ====================================
;                                SEH
; ====================================

; permet de rattrapper les fautes de page gnres
; par l'instruction "jmp eax"
SEH :
    lea eax,[esp+4]
    mov eax,[eax+except_handler.ContextRecord]
    mov dword [eax+CONTEXT.Eip], continue
    mov eax,ExceptionContinueExecution
    ret
    
; ====================================






